/**
 * Copyright (C) 2016 OGIS-RI Co., Ltd. All rights reserved.
 * 
 * This software is released under the MIT License.
 * http://opensource.org/licenses/mit-license.php
 */

var express = require('express');
var router = express.Router();

var passport = require('passport');

router.get('/', function(req, res, next) {
  var sessionId = req.cookies.express;
  if(checkSession(sessionId)){
    // Recԋp鏈B
  } else {
    res.redirect("/login");
  }
});

router.get('/login', passport.authenticate('openidconnect'));

router.get('/cb', passport.authenticate('openidconnect', {failureRedirect: '/'}),
  function(req, res) {
    if (req.authInfo && checkIssuerAndSub(req.authInfo.iss, req.authInfo.sub)) {
      sendMail(req.user._json.email);
      var user = req.authInfo.iss + "#" + req.authInfo.sub;
      var sessionId = createSession(user);
      res.cookie("express", sessionId,
        { secure: true, httpOnly: true }
      );
      res.redirect("/");
    } else {
      var error = { message: "Forbidden", error: { status: 403, stack: "" } }
      res.render("error", error);
    }
  }
);

function sendMail(mailaddr) {
  // [MB
}

function checkIssuerAndSub(iss, sub) {
  // IssuermFbooleanԂ֐B
}

function createSession(user) {
  // Session̐B
}

function checkSession(sessionId) {
  // Session̊mFB
}

module.exports = router;
